var DragMethod = /** @class */function () {
  function DragMethod(_a) {
    var _b = _a === void 0 ? {} : _a,
      _c = _b.key,
      key = _c === void 0 ? '' : _c,
      onMove = _b.onMove,
      onMoveEnd = _b.onMoveEnd;
    this.key = '';
    this.cache = {
      pageX: 0,
      pageY: 0,
      dragging: false
    };
    this.key = key;
    this.onMouseDown = this._onMouseDown.bind(this);
    this.onTouchStart = this._onMouseDown.bind(this);
    this.onMouseMove = this._onMouseMove.bind(this);
    this.onMouseUp = this._onMouseUp.bind(this);
    this.onMove = onMove;
    this.onMoveEnd = onMoveEnd;
  }
  DragMethod.prototype._onMouseMove = function (e) {
    var _a, _b, _c, _d;
    if (typeof this.onMove !== 'function') {
      return;
    }
    if (e.preventDefault) {
      e.preventDefault();
    } else {
      e.returnValue = false;
    }
    var pageX = (_a = e.pageX) !== null && _a !== void 0 ? _a : (_b = e.touches[0]) === null || _b === void 0 ? void 0 : _b.pageX;
    var pageY = (_c = e.pageY) !== null && _c !== void 0 ? _c : (_d = e.touches[0]) === null || _d === void 0 ? void 0 : _d.pageY;
    this.onMove({
      offsetX: pageX - this.cache.pageX,
      offsetY: pageY - this.cache.pageY,
      key: this.key
    });
    this.cache.pageX = pageX;
    this.cache.pageY = pageY;
  };
  DragMethod.prototype.clearListener = function () {
    window.removeEventListener('mousemove', this.onMouseMove);
    window.removeEventListener('touchmove', this.onMouseMove);
    window.removeEventListener('mouseup', this.onMouseUp);
    window.removeEventListener('touchend', this.onMouseUp);
  };
  DragMethod.prototype._onMouseUp = function () {
    this.clearListener();
    this.cache.dragging = false;
    if (typeof this.onMoveEnd === 'function') {
      this.onMoveEnd();
    }
  };
  DragMethod.prototype._onMouseDown = function (e) {
    var _a, _b, _c, _d;
    if (e.preventDefault && e.pageX) {
      e.preventDefault();
    } else {
      e.returnValue = false;
    }
    if (typeof this.onMove !== 'function' || this.cache.dragging) {
      return;
    }
    this.clearListener();
    var pageX = (_a = e.pageX) !== null && _a !== void 0 ? _a : (_b = e.touches[0]) === null || _b === void 0 ? void 0 : _b.pageX;
    var pageY = (_c = e.pageY) !== null && _c !== void 0 ? _c : (_d = e.touches[0]) === null || _d === void 0 ? void 0 : _d.pageY;
    this.cache.dragging = true;
    this.cache.pageX = pageX;
    this.cache.pageY = pageY;
    window.addEventListener('mousemove', this.onMouseMove);
    window.addEventListener('touchmove', this.onMouseMove, {
      passive: false
    });
    window.addEventListener('mouseup', this.onMouseUp);
    window.addEventListener('touchend', this.onMouseUp, {
      passive: false
    });
  };
  return DragMethod;
}();
export { DragMethod };