import { IndexedDBUtils, IndexedTable } from './indexed-db-utils';
export declare class Storage {
    private readonly utils;
    private readonly store;
    constructor(utils: IndexedDBUtils, store: string);
    getState(): Promise<any>;
    setState(values: any): void;
    merge(values: any): Promise<void>;
}
export interface StorageFactoryType {
    name: string;
    version: number;
    tables?: IndexedTable[];
}
export declare class IndexedStorage {
    private readonly name;
    private readonly version;
    utils: IndexedDBUtils;
    private _cache;
    private readonly tables;
    private connected;
    private connecting;
    constructor({ name, version, tables }: StorageFactoryType);
    register(tables: IndexedTable[]): void;
    connect(): Promise<void>;
    get(store: string): Storage;
}
