var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __read = this && this.__read || function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import { sleep } from 'pubo-utils';
import { IndexedDBUtils } from './indexed-db-utils';
var Storage = /** @class */function () {
  function Storage(utils, store) {
    this.utils = utils;
    this.store = store;
  }
  Storage.prototype.getState = function () {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        return [2 /*return*/, this.utils.get(this.store, 1)];
      });
    });
  };
  Storage.prototype.setState = function (values) {
    this.utils.put(this.store, __assign(__assign({}, values), {
      _id: 1
    }));
  };
  Storage.prototype.merge = function (values) {
    return __awaiter(this, void 0, void 0, function () {
      var state;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            return [4 /*yield*/, this.getState()];
          case 1:
            state = _a.sent();
            this.setState = __assign(__assign(__assign({}, state), values), {
              _id: 1
            });
            return [2 /*return*/];
        }
      });
    });
  };

  return Storage;
}();
export { Storage };
var IndexedStorage = /** @class */function () {
  function IndexedStorage(_a) {
    var name = _a.name,
      version = _a.version,
      tables = _a.tables;
    this._cache = {};
    this.tables = [];
    this.connected = false;
    this.connecting = false;
    this.name = name;
    this.version = version;
    this.tables = tables !== null && tables !== void 0 ? tables : [];
  }
  IndexedStorage.prototype.register = function (tables) {
    var _a;
    (_a = this.tables).push.apply(_a, __spreadArray([], __read(tables), false));
  };
  IndexedStorage.prototype.connect = function () {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (this.connected) {
              return [2 /*return*/];
            }

            if (!this.connecting) return [3 /*break*/, 4];
            _a.label = 1;
          case 1:
            if (!!this.connecting) return [3 /*break*/, 3];
            return [4 /*yield*/, sleep(100)];
          case 2:
            _a.sent();
            return [3 /*break*/, 1];
          case 3:
            return [2 /*return*/];
          case 4:
            this.connecting = true;
            this.utils = new IndexedDBUtils(this.name, this.version, this.tables);
            return [4 /*yield*/, this.utils.open()];
          case 5:
            _a.sent();
            this.connected = true;
            this.connecting = false;
            return [2 /*return*/];
        }
      });
    });
  };

  IndexedStorage.prototype.get = function (store) {
    if (!this._cache[store] && this.utils) {
      this._cache[store] = new Storage(this.utils, store);
    }
    return this._cache[store];
  };
  return IndexedStorage;
}();
export { IndexedStorage };