"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.blob2file = exports.blob2base64 = exports.blob2text = void 0;
var blob2text = function blob2text(blob) {
  return new Promise(function (resolve) {
    var reader = new FileReader();
    reader.onload = function (e) {
      return resolve(e.target.result);
    };
    reader.readAsText(blob);
  });
};
exports.blob2text = blob2text;
var blob2base64 = function blob2base64(blob) {
  return new Promise(function (resolve, reject) {
    var reader = new FileReader();
    if (!blob) {
      reject('文件爲空!');
    } else {
      reader.onload = function (e) {
        return resolve(e.target.result);
      };
      reader.onabort = function () {
        return reject();
      };
      reader.readAsDataURL(blob);
    }
  });
};
exports.blob2base64 = blob2base64;
var blob2file = function blob2file(blob, name, type) {
  return new File(blob, name, {
    type: type
  });
};
exports.blob2file = blob2file;